function [w_err,errs1,errs2,c_err,comerr,grad_errs,grad_errs2,grad_nm,wss,uss,vss] = Trun_DGD_solver1(Xs,Ys,alphas,eta,Maxiter,x_star,m,W,curr_index_starc,indexss)

k = length(  find( abs(x_star)>0)  );

[~,d] = size(Xs{1});

for i = 1:m

    %XXs{i} = Xs{i}'*Xs{i};
    XYs{i} = Xs{i}'*Ys{i};

    us(:,i)  = alphas(:,i);
    vs(:,i)  = alphas(:,i);
    ws  = us.^2 - vs.^2;

end



iter = 1;

while iter<Maxiter

   pre_us = us;
   pre_vs = vs;
   pre_ws = pre_us.^2 - pre_vs.^2;
 
   av_grad = zeros(d,1);
    for i = 1:m
        grads{i} = 1/(size(Xs{i},1))*(  Xs{i}'*(Xs{i}*pre_ws(:,i)) - XYs{i}  );
        % grads{i} = 1/(size(Xs{i},1))*(   XXs{i}*pre_ws(:,i) - XYs{i}  );
        us(:,i) = pre_us(:,i).*(1 - 4*eta*grads{i});
        vs(:,i) = pre_vs(:,i).*(1 + 4*eta*grads{i});

        if iter>=1
            us(:,i) = Trunc_Vec(us(:,i),k);
            vs(:,i) = Trunc_Vec(vs(:,i),k);
        end

        av_grad = av_grad + grads{i};
        grad_norm(i) = norm(  pre_us(:,i).*grads{i},'Inf'  );

    end
        grad_nm(iter) = max(grad_norm);
        
    av_grad = av_grad/m;
    for i = 1:m
        grad_diff(i) = norm(av_grad - grads{i},"inf");
    end

    grad_errs(iter) = max(grad_diff);

    us = us*W;
    vs = vs*W;
    ws = us.^2 - vs.^2;
    %W1{iter} = ws;


    temp_err1 = 0;
    for i = 1:m
       temp_err1 = temp_err1 + norm(ws(:,i) - x_star,"fro")^2;
    end
    errs1(iter) = temp_err1/m;

    us_av = us*ones(m,1)/m;
    vs_av = vs*ones(m,1)/m;
    ws_av = us_av.^2 - vs_av.^2;

    av_grad2 = zeros(d,1);
    for i = 1:m
        grads2{i} = us_av.*(  1/(size(Xs{i},1))*(  Xs{i}'*(Xs{i}*ws_av) - XYs{i}  )  );
        av_grad2 = av_grad2 + grads2{i};
    end

    av_grad2 = av_grad2/m;
    for i = 1:m
        grad_diff2(i) = norm(av_grad2 - grads2{i},"inf");
    end

    grad_errs2(iter) = max(grad_diff2);

    comerr(iter) = norm(ws_av(curr_index_starc),'inf');
    w_err(iter) = norm( ws_av - x_star,'fro')^2;
    
    

    % c_err(iter) = norm(ws - ws_av*ones(1,m),'fro')^2/m;
    temp_c_err = ws - ws_av*ones(1,m);
    c_err(iter) = norm(temp_c_err(:),'inf');

    %W2{iter} = ws_av;
    errs2(iter) = norm(ws_av-x_star,"fro")^2;
    % errs2(iter) = norm(ws_av-x_star,"Inf");

     wss{iter} = ws;
     uss{iter} = us;
     vss{iter} = vs;

    fprintf("Iter = %d, errs1 = %.8e, errs2 = %.8e\n",iter,errs1(iter),errs2(iter));

    iter = iter + 1;
    


end